var used = [];

//
// Method for processing chat rolls
//

function ProcessMessageContent(rollName, formula, rolling, result)
{
	window.open("talespire://result/"+rollName.trim()+"/"+formula.trim()+"/"+rolling.trim(), "_blank");
}

//
// Helper Methods For Detecting Messages
//

function GetOldMessages()
{
    var content = document.body.innerHTML;
	found = 0;
	console.log("Checking For Old Messages");
	while(content.indexOf("data-messageid=\"")>-1)
	{
		content = content.substring(content.indexOf("data-messageid=\"")+16);
		var msgId = content.substring(0,content.indexOf("\""));
		content = content.substring(content.indexOf(">")+1);
									
		if(used.includes(msgId)==false)
		{
			console.log("Old Message: "+msgId);
			used.push(msgId);
			found = 1;
		}
	}
	if(found==1)
	{
		// Get more old messages
		setTimeout(()=>{GetOldMessages();},500); 
	}
	else
    {
		// Get new messages
		setTimeout(()=>{GetNewMessages();},1000); 
	}		
}

function GetNewMessages()
{
    var content = document.body.innerHTML;
	// console.log("Checking For New Messages");
	while(content.indexOf("data-messageid=\"")>-1)
	{
		content = content.substring(content.indexOf("data-messageid=\"")+16);
		var msgId = content.substring(0,content.indexOf("\""));
		var rollName = "";
		var formula = "";
		var rolling = "";
		var result = "";
		content = content.substring(content.indexOf(">")+1);
									
		if(used.includes(msgId)==false)
		{
			console.log("New Message: "+msgId);
			used.push(msgId);
			content = content.substring(content.indexOf("Rolling")+7);
			formula = content.substring(0,content.indexOf("="));
			formula = strip(formula);
			formula = evaluate(formula);
			content = content.substring(content.indexOf("=")+1);
			rolling = content.substring(0,content.indexOf("\">"));
			rolling = stripHtml(rolling);
			rolling = strip(rolling);
			while(rolling.indexOf("+")>-1){rolling = rolling.replace("+","/");}
			while(rolling.indexOf("(")>-1){rolling = rolling.replace("(","");}
			while(rolling.indexOf(")")>-1){rolling = rolling.replace(")","");}
			rolling = rolling.split('/').slice(0, parseInt(formula)).join('/');
			console.log("Rolling: "+rolling);
			content = content.substring(content.indexOf("\">")+2);
			result = content.substring(0,content.indexOf("<"));
			if(content.indexOf("sheet-label")>-1)
			{
				content = content.substring(content.indexOf("sheet-label"));
				content = content.substring(content.indexOf("<span>")+6);
				if(content.substring(0,7)=="<a href")
				{
					content = content.substring(content.indexOf(">")+1);
					rollName = content.substring(0,content.indexOf("<"));
				}
				else
				{
					rollName = content.substring(0,content.indexOf("<"));
				}
			}
			else
			{
				rollName = "Damage";
			}
			console.log("Roll Name: "+rollName);
			ProcessMessageContent(rollName, formula, rolling, result);
	    }
	}
	// Get new messages
	setTimeout(()=>{GetNewMessages();},1000); 
}

function stripHtml(html)
{
   let tmp = document.createElement("DIV");
   tmp.innerHTML = html;
   return tmp.textContent || tmp.innerText || "";
}

function stripSpace(txt)
{
	let result = "";
	for(var i=0; i<txt.length; i++)
	{
		if(txt.substring(i,i+1)!=" "){ result = result + txt.substring(i,i+1); }
	}
	return result;
}

function strip(txt)
{
	let tag = false;
	let result = "";
	for(var i=0; i<txt.length; i++)
	{
		if(txt.substring(i,i+1)=="["){ tag = true; }
		else if(txt.substring(i,i+1)=="]"){ tag = false; }
		else if(!tag){ result = result + txt.substring(i,i+1); }
	}
	return result;
}

function evaluate(formula)
{
	formula = formula.replace("+-","-");
	formula = stripSpace(formula + "+0");
	formula = formula.replace("cs>20","");
	formula = formula.replace("cs>19","");
	formula = formula.replace("cs>18","");
	formula = formula.replace("cs>17","");
	formula = formula.replace("cs>16","");
	formula = formula.replace("cs>15","");
	let temp = formula;
	let modifier = 0;
	let pos1 = -1;
	let pos2 = -1;
	while(temp.indexOf("+")>-1 || temp.indexOf("-")>-1)
	{
		pos1 = temp.indexOf("+");
		pos2 = temp.indexOf("-");
		if(pos1<0){pos1=999;}
		if(pos2<0){pos2=999;}
		modifier = modifier + parseInt(temp.substring(Math.min(pos1,pos2)));
		temp = temp.substring(Math.min(pos1,pos2)+1);
	}
	pos1 = formula.indexOf("+");
	pos2 = formula.indexOf("-");
	if(pos1<0){pos1=999;}
	if(pos2<0){pos2=999;}
	formula = (formula.substring(0,Math.min(pos1,pos2)).trim()+"+"+modifier).replace("+-","-");
	console.log("Formula: "+formula);
	return formula;
}

//
// Method for starting the sequence
//

function Start()
{
	GetOldMessages();
}


setTimeout(()=>{Start();},10000); 